int led_pin1 = 11;    // the number of the first LED pin
int ledState1 = LOW;             // ledState used to set the first LED
long previousMillis1 = 0;        // will store last time LED 1 was updated
long rate1;           // first led rate

int led_pin2 = 5;    // the number of the first LED pin
int ledState2 = LOW;             // ledState used to set the first LED
long previousMillis2 = 0;        // will store last time LED 1 was updated
long rate2;           // first led rate

int button_pin = 2;     // were we will store the reading from the button
int pot_value;       // were we will store the reading from the knob
int button_state;       // were we will store the reading from the button

int prev_button_state;       // store the last button state we read
int latch;       // is the button turning things on or off

int led_output1, led_output2;
int led_latch;


void setup() {

  pinMode(led_pin1, OUTPUT);
  pinMode(led_pin2, OUTPUT);

  pinMode(button_pin, INPUT_PULLUP); // set the pin to read a button.

}


void loop()
{

  pot_value = analogRead(A0); // analogRead will return a value from 0 to 1023

  rate1 = pot_value*5;

  prev_button_state = button_state;

  button_state = digitalRead(button_pin);
  ledState2 = !button_state;

  if (button_state == 0 && prev_button_state == 1) {
    //the button has been pressed
    latch = !latch;
  }

  analogWrite(led_pin2, pot_value/4);

  unsigned long currentMillis = micros(); // only need to do this once

  if (latch == 0) {
    if (currentMillis - previousMillis1 > rate1) {
      previousMillis1 = currentMillis;

      if (led_latch == 1) {
        led_output1++;
      }

      if (led_latch == 0) {
        led_output1--;
      }
      
      if (led_output1 > 255) {
        led_latch=0;
      }
      
      if (led_output1 < 1) {
        led_latch=1;
      }

      analogWrite(led_pin1, led_output1); // can output 256 values
    }

  }
  if (latch == 1) {
    digitalWrite(led_pin1, 0);
    led_output1 = 0;
  }
}

