int led_pin1 = 12;    // the number of the first LED pin
int ledState1 = LOW;             // ledState used to set the first LED
long previousMillis1 = 0;        // will store last time LED 1 was updated
long rate1;           // first led rate

int led_pin2 = 4;    // the number of the first LED pin
int ledState2 = LOW;             // ledState used to set the first LED
long previousMillis2 = 0;        // will store last time LED 1 was updated
long rate2;           // first led rate

int button_pin = 2;     // were we will store the reading from the button
int pot_value;       // were we will store the reading from the knob
int button_state;       // were we will store the reading from the button

int prev_button_state;       // store the last button state we read
int latch=1;       // is the button turning things on or off


void setup() {

  pinMode(led_pin1, OUTPUT);
  pinMode(led_pin2, OUTPUT);

  pinMode(button_pin, INPUT_PULLUP); // set the pin to read a button.

}


void loop()
{

  pot_value = analogRead(A0); // analogRead will return a value from 0 to 1023

  rate1 = pot_value;

  prev_button_state = button_state;

  button_state = digitalRead(button_pin);
  ledState2 = !button_state;

  if (button_state==0 && prev_button_state==1){ 
    //the button has been pressed
    latch=!latch;
  }

  digitalWrite(led_pin2, !latch);

  unsigned long currentMillis = millis(); // only need to do this once
  if (latch == 0) {
    if (currentMillis - previousMillis1 > rate1) {
      previousMillis1 = currentMillis;

      if (ledState1 == LOW)
        ledState1 = HIGH;
      else
        ledState1 = LOW;

      digitalWrite(led_pin1, ledState1);
    }

  }
  if (latch == 1) {
    digitalWrite(led_pin1, 0);
  }
}

